
----------------------------------------------
-- Variables
----------------------------------------------

local moneyFrameObject;
local BBar_BASEBARSZ = 56;		-- Extra to add to the money frame

local BBar_TOTALITEMS = 31;		-- Total number of items including titles (size of BBarObjects_Shown array)
local BBar_MINCURRENCYID = 10;	-- Smallest possible currency ID (below this are title IDs)
local BBarObjects = {1, 395, 396, 392, 390, 2, 61, 361, 698, 402, 81, 3, 515, 241, 416, 391, 614, 615, 697, 4, 384, 398, 394, 385, 397, 393, 400, 401, 676, 677, 5};
local BBarObjects_Shown = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

local BBarObjectsItems = {};
local BBarObjectsItems_Shown = {};
local lastSettingsItem = nil;
local defaultSettingsheight = 0;
local scrollSettingsWindow = 0;		-- Set to 1 if the settings need to be scrolled

local TooltipStorage = {};

--[[
local BBarObjects_Points = {395, 396, 392, 390};
local BBarObjects_Professions = {61, 361, 698, 402, 81};
local BBarObjects_Items = {515, 241, 416, 391, 614, 615, 697};
local BBarObjects_Archaeology = {384, 398, 394, 385, 397, 393, 400, 401, 676, 677};

390 = Conquest Points
392 = Honor Points
395 = Justice Points
396 = Valor Points

61 = Dalaran Jewelcrafter's Token
361 = Illustrious Jewelcrafter's Token
698 = Zen Jewelcrafter's Token
402 = Ironpaw Token
81 = Epicurean's Award

515 = Darkmoon Prize Ticket
241 = Champion's Seal
416 = Mark of the World Tree
391 = Tol Barad Commendation
614 = Mote of Darkness
615 = Essence of Corrupted Deathwing
697 = Elder Charm of Good Fortune

384 = Dwarf Archaeology Fragment
398 = Draenei Archaeology Fragment
394 = Night Elf Archaeology Fragment
385 = Troll Archaeology Fragment
397 = Orc Archaeology Fragment
393 = Fossil Archaeology Fragment
399 = Vrykul Archaeology Fragment
400 = Nerubian Archaeology Fragment
401 = Tol'vir Archaeology Fragment
676 = Pandaren Archaeology Fragment
677 = Mogu Archaeology Fragment
]]--

----------------------------------------------
-- Functions
----------------------------------------------


SLASH_BBAR_RESET1 = '/bbar';
SlashCmdList["BBAR_RESET"] = function()
	_G["BBarFrame"]:ClearAllPoints();
	_G["BBarFrame"]:SetPoint("CENTER", 0, 0);
	_G["BBarSettingsFrame"]:ClearAllPoints();
	_G["BBarSettingsFrame"]:SetPoint("CENTER", 0, 0);
end


function BBar_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE");

	-- Store the money frame object and remove the scripts
	moneyFrameObject = _G[self:GetName().."MoneyFrame"];
	_G[moneyFrameObject:GetName().."CopperButton"]:SetScript("OnClick", nil);
	_G[moneyFrameObject:GetName().."SilverButton"]:SetScript("OnClick", nil);
	_G[moneyFrameObject:GetName().."GoldButton"]:SetScript("OnClick", nil);

	ValuesToString();	-- Setup defaults
	BBar_BuildSettingsFrame();

end


function BBar_OnEvent(self, event, ...)

	if( event == "PLAYER_ENTERING_WORLD" ) then
		MoneyFrame_UpdateMoney(moneyFrameObject);
		BBar_UpdateBar(self);
	end
	if( event == "PLAYER_MONEY" ) then
		MoneyFrame_UpdateMoney(moneyFrameObject);
		BBar_UpdateBar(self);
	end
	if( event == "BAG_UPDATE" ) or ( event == "CURRENCY_DISPLAY_UPDATE" ) then
		BBar_UpdateBar(self);		-- Would be nice to know what changed on bag update so it only updates if needed
	end
	if( event == "VARIABLES_LOADED" ) then
	--	ValuesToString();	-- Reset saved string
		StringToValues();	-- parse variable string
	end
end


function BBar_ToggleSettings(self)

	if(_G["BBarSettingsFrame"]:IsShown()) then
			HideUIPanel(_G["BBarSettingsFrame"]);
	else	ShowUIPanel(_G["BBarSettingsFrame"]);
	end
end


function BBar_SettingsCheckOnClick(self)

	local obj = self:GetParent();
	if(obj.positionID < 100) then
		if(self:GetChecked()) then	BBarObjects_Shown[obj.positionID] = 1;
		else						BBarObjects_Shown[obj.positionID] = 0;
		end
	else
		if(self:GetChecked()) then	BBarObjectsItems_Shown[obj.positionID - 100] = 1;
		else						BBarObjectsItems_Shown[obj.positionID - 100] = 0;
		end
	end
	BBar_UpdateBar(_G["BBarFrame"]);
	ValuesToString();	-- Store changes
end


function BBar_SettingsRemoveOnClick(self)

	local iPos = self:GetParent().positionID - 100;

	-- Remove it from the bar while it's still valid
	BBarObjectsItems_Shown[iPos] = 0;
	BBar_UpdateBar(_G["BBarFrame"]);

	-- Remove it completly
	BBarObjectsItems[iPos] = 0;
	BBar_UpdateSettings(_G["BBarSettingsFrame"]);
	ValuesToString();	-- Store changes
end


function BBar_SettingsScrollUpdate()

-- Messy hack to scroll the window after an item is added.
-- Need to skip 2 frames to allow the window to be drawn before the scroll bar will move to show the new content.
	if(scrollSettingsWindow > 0) then
		if(scrollSettingsWindow == 2) then
			_G["BBarScrollFrame"]:SetVerticalScroll(100000);
			scrollSettingsWindow = 0;
		else	scrollSettingsWindow = scrollSettingsWindow + 1;
		end
	end
end


function BBar_ShowCurrencyTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT");
	if(self.currencyID > BBar_MINCURRENCYID)	then	GameTooltip:SetCurrencyByID(self.currencyID);	end
	if(self.currencyID < 0)						then	GameTooltip:SetItemByID(abs(self.currencyID));	end
end


function BBar_ShowInfoTooltip(self)

	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
	GameTooltip:AddDoubleLine("BBar", "[ Made by Bynun ]", 0.9, 0.7, 0.1, 0.2, 1 ,0.2)

	_, TooltipStorage[1] = GameTooltipTextLeft1:GetFont();
	TooltipStorage[2] = GameTooltipTextLeft1:GetHeight();
	GameTooltipTextLeft1:SetFont(GameTooltipTextLeft1:GetFont(), 18);
	GameTooltipTextLeft1:SetHeight(24);

	_, TooltipStorage[3] = GameTooltipTextRight1:GetFont();
	TooltipStorage[4], _, _, TooltipStorage[5], TooltipStorage[6] = GameTooltipTextRight1:GetPoint(1);
	GameTooltipTextRight1:SetFont(GameTooltipTextRight1:GetFont(), 11);
	GameTooltipTextRight1:SetPoint("TOPRIGHT", -16, -14);

	GameTooltip:AddLine("|cffffffff::|r |cff44ff44/bbar|r Reset the bars position to the center of the screen.", 0.8, 0.8, 0.8);
	TooltipStorage[7] = GameTooltipTextLeft2:GetHeight();
	GameTooltipTextLeft2:SetHeight(20);
	GameTooltip:AddLine("|cffffffff::|r Drag an item from your bag to the settings window to add it as a new currency.",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("   You can then view that item's count on the main bar.",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r You can display an unlimited number of items",  0.8, 0.8, 0.8);
	TooltipStorage[8] = GameTooltipTextLeft5:GetHeight();
	GameTooltipTextLeft5:SetHeight(20);
	GameTooltip:AddLine("|cffffffff::|r Item count includes all bag and bank items of that type.",  0.8, 0.8, 0.8);
	TooltipStorage[9] = GameTooltipTextLeft6:GetHeight();
	GameTooltipTextLeft6:SetHeight(20);

	GameTooltip:Show();
end

function BBar_HideInfoTooltip(self)

	GameTooltip:Hide();

	-- Set it all back again
	GameTooltipTextLeft1:SetFont(GameTooltipTextLeft1:GetFont(), TooltipStorage[1]);
	GameTooltipTextLeft1:SetHeight(TooltipStorage[2]);

	GameTooltipTextRight1:SetFont(GameTooltipTextRight1:GetFont(), TooltipStorage[3]);
	GameTooltipTextRight1:SetPoint(TooltipStorage[4], TooltipStorage[5], TooltipStorage[6]);

	GameTooltipTextLeft2:SetHeight(TooltipStorage[7]);
	GameTooltipTextLeft5:SetHeight(TooltipStorage[8]);
	GameTooltipTextLeft6:SetHeight(TooltipStorage[9]);

end


---------------------------


function BBar_UpdateBar(self)

	-- Add new tokens
	local priorObj = nil;
	local extraWidth = 0;
	local iPos = 1;

	-- Currencies
	local i = 1;
	while (BBarObjects[i] ~= nil) do
		if(BBarObjects[i] > BBar_MINCURRENCYID) then
			local outWidth, outObj = BBar_AddNewCurrencyToken(self, priorObj, BBarObjects[i], BBarObjects_Shown[i]);
			if(outWidth > 0)	then	extraWidth = extraWidth + outWidth;		end
			if(outObj ~= 0)		then	priorObj = outObj;						end
			iPos = iPos + 1;
		end
		i = i + 1;
	end

	-- Custom items
	for i = 1, getn(BBarObjectsItems), 1 do
		if(BBarObjectsItems[i] > 0) then
			local outWidth, outObj = BBar_AddNewCurrencyToken(self, priorObj, -BBarObjectsItems[i], BBarObjectsItems_Shown[i]);
			if(outWidth > 0)	then	extraWidth = extraWidth + outWidth;		end
			if(outObj ~= 0)		then	priorObj = outObj;						end
			iPos = iPos + 1;
		end
	end
	
	local moneyWidth = _G["BBarFrameMoneyFrame"]:GetWidth();
	self:SetWidth(BBar_BASEBARSZ + moneyWidth + extraWidth);
end


function BBar_UpdateSettings(self)

-- Set the check boxes depending on if they are shown
	for i = 1, BBar_TOTALITEMS, 1 do
		if(BBarObjects[i] > BBar_MINCURRENCYID and BBarObjects_Shown[i] > 0) then
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(true);
		else
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(false);
		end
	end

	-- Custom items
	local scrollChild = _G["BBarScrollFrameChild"];
	local priorItem = lastSettingsItem;
	local scrollChildHeight = defaultSettingsheight;

	local name = "";
	local icon = "";
	local numAdded = 0;
	for i = 1, getn(BBarObjectsItems), 1 do
		if(BBarObjectsItems[i] > 0) then
			name = GetItemInfo(BBarObjectsItems[i]);
			icon = GetItemIcon(BBarObjectsItems[i]);
		end
		local returnItem = BBar_CreateSettingsItem(name, icon, scrollChild, priorItem, i + 100);
		if(returnItem ~= priorItem) then
			priorItem = returnItem;
			priorItem.currencyID = -BBarObjectsItems[i];
			scrollChildHeight = scrollChildHeight + 30;
			if(BBarObjectsItems_Shown[i] > 0) then
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(true);
			else
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(false);
			end
			numAdded = numAdded + 1;
		end
	end
	-- Add 'No custom items' text if needed
	local returnItem = BBar_CreateSettingsItem("No custom items", "", scrollChild, priorItem, 100);
	if(numAdded == 0) then
		returnItem:Show();
		scrollChildHeight = scrollChildHeight + 30;
	else	returnItem:Hide();
	end
	scrollChild:SetHeight(scrollChildHeight);
end


function BBar_AcceptItem()

	-- Add the dropped item to the custom items list
	local infoType, itemID = GetCursorInfo();
	if(infoType == "item") then
		-- Check it's not already added
		for i = 1, getn(BBarObjectsItems), 1 do
			if(BBarObjectsItems[i] == itemID) then
				ClearCursor();
				return;
			end
		end

		-- Add it to the end of the list
		local iPos = getn(BBarObjectsItems) + 1;
		BBarObjectsItems[iPos] = itemID;
		BBarObjectsItems_Shown[iPos] = 1;	-- Shown as default
		ClearCursor();
		BBar_UpdateBar(_G["BBarFrame"]);
		BBar_UpdateSettings(_G["BBarSettingsFrame"]);
		ValuesToString();	-- Store changes

		-- Scroll the window to the bottom to make the newly added item visable.
	--	scrollSettingsWindow = 1;
	end
end


---------------------------


function BBar_AddNewCurrencyToken(self, priorObj, currencyID, shown)

	local thisObj = _G["BBarCurrencyToken"..currencyID];

	-- Check if this button should be made or shown
	if(shown == 0) then
		if(thisObj) then thisObj:Hide(); end
		return 0, 0;
	end

	-- if this button doesn't exist yet, create it
	if( not thisObj ) then
		thisObj = CreateFrame("BUTTON", "BBarCurrencyToken"..currencyID, self, "BBarCurrencyFrameTemplate");
	else	thisObj:ClearAllPoints();
	end

	-- Get this currency info and update the button
	local objWidth = 0;
	local name, count, icon;
	if(currencyID > BBar_MINCURRENCYID) then
		name, count, icon = GetCurrencyInfo(currencyID);
		icon = "Interface\\Icons\\"..icon;
	elseif(currencyID < 0) then		-- Item
		name = GetItemInfo(abs(currencyID));
		count = GetItemCount(abs(currencyID), true);
		icon = GetItemIcon(abs(currencyID));
	end

	if( name and name ~= "" ) then
		if( count <= 99999 )
			then	thisObj:SetText(count);
			else	thisObj:SetText("*");
		end
		thisObj:SetNormalTexture(icon);
		thisObj.currencyID = currencyID;
		thisObj:Show();
		objWidth = thisObj:GetTextWidth() + thisObj:GetWidth() + 28;
		if(priorObj ~= nil)	then	thisObj:SetPoint("LEFT", priorObj, "RIGHT", priorObj:GetTextWidth() + 28, 0);
		else						thisObj:SetPoint("LEFT", _G["BBarFrameMoneyFrame"], "RIGHT", 13, 0);
		end
	else	thisObj:Hide();	end
	return objWidth, thisObj;
end


function BBar_CreateSettingsItem(name, icon, parent, priorItem, iPos)

	-- If this item doesn't exist yet, create it
	local item = _G["BBarSettingsItem"..iPos];
	if( not item ) then
		item = CreateFrame("Frame", "BBarSettingsItem"..iPos, parent, "BBarSettingsItemTemplate");
	else	item:ClearAllPoints();
	end
	local textItem = _G[item:GetName().."Text"];
	textItem:SetText(name);

	local obj = -1;		-- Custom item
	if(iPos < 100) then	obj = BBarObjects[iPos];	end

	if(iPos == 100) then	-- Special text only item (not title)
		_G[item:GetName().."Icon"]:Hide();
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();
	elseif(obj > 0 and obj < BBar_MINCURRENCYID) then		-- Title
		textItem:SetWidth(200);		-- Widen it for proper spacing
		textItem:SetJustifyH("CENTER");
		textItem:SetTextColor(0.8, 1, 0.7, 1);
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();

		if(obj == 1) then	-- The first item needs to be set it up relative to the scroll child
			item:SetPoint("TOP", parent, "TOP", 0, 4);
			return item;
		end
	else
		if(obj < 0) then	-- Custom item!
			if(BBarObjectsItems[iPos - 100] > 0) then	-- Only show valid ones
				local _, _, itemQuality = GetItemInfo(BBarObjectsItems[iPos - 100]);
				textItem:SetTextColor(GetItemQualityColor(itemQuality));
				_G[item:GetName().."Icon"]:SetTexture(icon);
				_G[item:GetName().."Check"]:Show();
				_G[item:GetName().."Remove"]:Show();
			else
				item:Hide();
				return priorItem;	-- Skip it
			end
		else				-- Currency
			_G[item:GetName().."Icon"]:SetTexture("Interface\\Icons\\"..icon);
			_G[item:GetName().."Check"]:Show();
			_G[item:GetName().."Remove"]:Hide();
		end
		item.positionID = iPos;
	end
	item:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, -4);
	return item;
end


function BBar_BuildSettingsFrame()

	local scroll = CreateFrame("ScrollFrame", "BBarScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	scroll:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -29);
	scroll:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -29, 36);

	local scrollChild = CreateFrame("Frame", "BBarScrollFrameChild", scroll);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(266);

	local scrollChildHeight = 0;
	local priorItem = scrollChild;
	
	-- Currencies
	for i = 1, BBar_TOTALITEMS, 1 do
		if(BBarObjects[i] < BBar_MINCURRENCYID) then
			if(BBarObjects[i] == 1) then
				priorItem = BBar_CreateSettingsItem("Points", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 2) then
				priorItem = BBar_CreateSettingsItem("Professions", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 3) then
				priorItem = BBar_CreateSettingsItem("Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 4) then
				priorItem = BBar_CreateSettingsItem("Archaeology", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 5) then
				priorItem = BBar_CreateSettingsItem("Custom Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			end
		elseif (BBarObjects[i] > BBar_MINCURRENCYID) then
			local name, count, icon = GetCurrencyInfo(BBarObjects[i]);
			priorItem = BBar_CreateSettingsItem(name, icon, scrollChild, priorItem, i);
			priorItem.currencyID = BBarObjects[i];
			scrollChildHeight = scrollChildHeight + 30;
		end
	end

	-- Store some values for use when we add the custom items
	lastSettingsItem = priorItem;
	defaultSettingsheight = scrollChildHeight;

	scrollChild:SetHeight(scrollChildHeight);
	scroll:SetScrollChild(scrollChild);
end


---------------------------


-- Convert between arrays and strings for saving
function ValuesToString()

	BBarShownCurrency = "";
	for i = 1, BBar_TOTALITEMS, 1 do
		BBarShownCurrency = BBarShownCurrency..tostring(BBarObjects_Shown[i]);
	end

	BBarCustomItems = "";
	BBarShownItems = "";
	for i = 1, getn(BBarObjectsItems), 1 do
		if(BBarObjectsItems[i] > 0) then
			BBarCustomItems = BBarCustomItems..tostring(BBarObjectsItems[i]).." ";
			BBarShownItems = BBarShownItems..tostring(BBarObjectsItems_Shown[i]);
		end
	end
end

function StringToValues()

	for i = 1, BBar_TOTALITEMS, 1 do
		BBarObjects_Shown[i] = tonumber(strbyte(BBarShownCurrency, i)) - 48;	-- Convert ascii code to number
	end

	local items = { strsplit(" ", BBarCustomItems) };
	for i = 1, getn(items) - 1, 1 do	-- -1 as last item is always invalid
		if(tonumber(items[i]) > 0) then
			BBarObjectsItems[i] = tonumber(items[i]);
			BBarObjectsItems_Shown[i] = tonumber(strbyte(BBarShownItems, i)) - 48;	-- Convert ascii code to number
		end
	end
end

function _T(text)
	DEFAULT_CHAT_FRAME:AddMessage(text, 1, 1, 1);
end
